%%
% PLOTTING OF BAR GRAPH SHOWING THE % OF REALIZATIONS IN WHICH A REPAIR CLASS IS TRIGGERED

function [Mean_RCcount, Mean_GroupRT] = RCplotting(Folder_Path,n_real,n_Floors,n_PG,RS,GI,Phases)
% n_real = number of realizations = variable 'n_real' in Downtime_SP3.m
% n_Floors = number of floors in the building 
filename1 = append(Folder_Path,'Repair_Class_All.xlsx');
Repair_Class_All = xlsread(filename1,1,'A1:BXX715');

filename2 = append(Folder_Path,'AllReal_RDCases.xlsx');
Residual_Drift = xlsread(filename2,1,'A1:BXX1');

filename3 = append(Folder_Path,'Repair_Times_RC2.xlsx');
Repair_Times_RC2 = xlsread(filename3,1,'A1:BXX715');

filename4 = append(Folder_Path,'Worker_Allocation_RC2.xlsx');
Worker_Allocation_RC2 = xlsread(filename4,1,'A1:BXX119');

filename5=append(Folder_Path,'AllReal_CollapseCases.xlsx');
Collapse = xlsread(filename5,1,'A1:BXX1');

filename6 = append(Folder_Path,'RS_Story_Identifier.xlsx');
Story_Identifier = xlsread(filename6,1,'B1:B715');

filename7 = append(Folder_Path,'Floor&Direction_Identifier.xlsx');
[~,~,Group_Identifier] = xlsread(filename7,1,'B5:AAN5');
Group_Identifier = transpose(Group_Identifier);
        
n_Phase = size(Phases,1);

Group_maxRC = zeros(1,n_real);
Group_RTperphase = zeros(n_Phase,n_real);
for i = 1:n_real
    p=1;
    Group_RC_Perstory = 0;
    RTperphase = zeros(n_Phase,1000);              % '1000' is an arbitrary large number
    for k=1:n_Phase
        for r = Phases(k,1):Phases(k,2)
            for j = 1:n_PG
                if Group_Identifier{j,1} == GI
                if Story_Identifier(j,1) == r
                    Group_RC_Perstory(p) = Repair_Class_All(j,i);
                    RTperphase(k,p) = RTperphase(k,p) + Repair_Times_RC2(j,i);
                    p=p+1;
                end
                end
                       
            end
        end
        Group_RTperphase(k,i) = sum(RTperphase(k,:)); 
    end
    Group_maxRC(1,i) = max(Group_RC_Perstory);
end
% Modification for elevator repair time
% Elevators are modelled  only on the first floor of the structure and hence the repair time is
% concentrated only on the first floor. Since elevator rail and door 
% repairs will be carried out over all floors of the building, we
% equally divide the elevator repair time over all floors of the building. 
% if RS == 6
%     for i=1:n_real
%         RT_Elevator = Group_RTperphase(1,i);      
%         RT_Elevator_per_floor = RT_Elevator/n_Floors;   
%         for k=1:size(Phases,1)
%         Group_RTperphase(k,i) = RT_Elevator_per_floor * (Phases(k,2) - Phases(k,1) + 1);
%         end
%     end
% end

% Calculate the repair time acocunting for labor allocation limitations 
Total_Workers_Allocated = zeros(size(Phases,1),n_real);
Group_RT_Lim = zeros(size(Phases,1),n_real);
for i=1:n_real
    for k=1:size(Phases,1)
        for r = Phases(k,1):Phases(k,2)
            p=r-1;
            Total_Workers_Allocated(k,i) = Total_Workers_Allocated(k,i) + Worker_Allocation_RC2(p*7+RS,i);
        end
        if Total_Workers_Allocated(k,i) == 0
            Group_RT_Lim(k,i) = Group_RTperphase(k,i);
        else
            Group_RT_Lim(k,i) = Group_RTperphase(k,i) / Total_Workers_Allocated(k,i);
        end
    end
end

% Calculate the total repair time for the group for all phases 
Group_TotalRT = zeros(1,n_real);
for i=1:n_real
    Group_TotalRT(1,i) = sum(Group_RT_Lim(:,i));
end

% Accounting for collapse and demolition due to residual drift
n_collapse=0;
for i=1:n_real 
    if Collapse(1,i)==1
        Group_maxRC(1,i) = 0;
        n_collapse = n_collapse+1;
    end
end
n_RDcollapse=0;
for i=1:n_real
    if Residual_Drift(1,i) == 1
        Group_maxRC(1,i) = 0;
        n_RDcollapse = n_RDcollapse+1;
    end
end

Mean_GroupRT = sum(Group_TotalRT(1,:));
% Mean_GroupRT = sum(Group_TotalRT(1,:)) / (n_real-n_RDcollapse-n_collapse);

Count_RC1 = 0;
Count_RC2 = 0;
Count_RC3 = 0;
Count_RC4 = 0;
Count_RC5 = 0;
for i=1:n_real
    switch(Group_maxRC(1,i))
        case(1)
        Count_RC1 = Count_RC1 + 1;
        case(2)
        Count_RC2 = Count_RC2 + 1;
        case(3)
        Count_RC3 = Count_RC3 + 1;
        case(4)
        Count_RC4 = Count_RC4 + 1;
        case(5)
        Count_RC5 = Count_RC5 + 1;
    end
end
Count_RC = [Count_RC5 Count_RC4 Count_RC3 Count_RC2 Count_RC1];

Mean_RCcount = Count_RC./(n_real-n_RDcollapse-n_collapse)*100;
end
%%
% This function assists in the plotting of a horizontal bar graph showing 
% the percent of realizations in which a repair class is triggered for a
% given group of PGs and the contribution of components to the downtime
        
        
        
        